#include "stdafx.h"
#include "structs.h"

const long ERR_UNK = -1L;
const long NO_ERR = 0;

int rslt = 0;
char* chPkg;
normalPkg_t sndNmlPkg;
normalPkg_t rcvNmlPkg;
tracePkg_t  sndTrcPkg;
tracePkg_t  rcvTrcPkg;
rspPtsPkg_t sndRspPkg;
rspPtsPkg_t rcvRspPkg;
//bigBufferPkg_t bigBuff;

Client client("127.0.0.1");

void ZeroNmlPkgsNxtEvnt()
{
    memset(&sndNmlPkg, 0, NORMAL_PACKAGE_SIZE);     // null out normal package
    memset(&rcvNmlPkg, 0, NORMAL_PACKAGE_SIZE);     // null out normal package
    sndNmlPkg.basInf.eventId = NextEventId();
}

void ZeroTrcPkgsNxtEvnt()
{
	memset(&sndTrcPkg, 0, TRACE_PACKAGE_SIZE);     // null out trace package
    memset(&rcvTrcPkg, 0, TRACE_PACKAGE_SIZE);     // null out trace package
    sndTrcPkg.basInf.eventId = NextEventId();
}

void ZeroRspPkgsNxtEvnt()
{
    memset(&sndRspPkg, 0, RESPONSE_POINTS_PACKAGE_SIZE);     // null out responce package
    memset(&rcvRspPkg, 0, RESPONSE_POINTS_PACKAGE_SIZE);     // null out responce package
    sndNmlPkg.basInf.eventId = NextEventId();
    sndRspPkg.basInf.eventId = sndNmlPkg.basInf.eventId;
}

/*=======================================================================
-----------------------------------------------------------------------*/
unsigned long NextEventId()
{
    static unsigned long nxtEv = 0;
    if (nxtEv >= MAXUINT32) nxtEv =0;
    return nxtEv++;
};

 LB_API2_32_64_API LB_SetSysTimeOut(long newTimeout)
{
	return ERR_UNK;
} // SetSysTimeOut

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_DriverVersion(void)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_DriverVersion;
    // set parms ........................................................
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SensorCnt(void)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SensorCnt;
    // set parms ........................................................
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SensorCnt

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_BlinkLED_SN(char* SN)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_BlinkLED_SN;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_BlinkLED_SN

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_BlinkLED_Addr(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_BlinkLED_Addr;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_BlinkLED_Addr

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_BlinkLED_Idx(long idx)												// JRS Added 
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_BlinkLED_Idx;
    // set parms ........................................................
    sndNmlPkg.basInf.idx = idx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_BlinkLED_Addr


/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SensorList(SensorDescrption* SD, long cnt)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SensorList;
    // set parms ........................................................
    sndNmlPkg.prms.longs[0] = cnt;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    memcpy(SD,rcvNmlPkg.sd.sd,sizeof(SensorDescrption)*rcvNmlPkg.sd.cnt);
    return rcvNmlPkg.basInf.result;
} // LB_SensorList

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetAddress_SN(char* SN)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetAddress_SN;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_GetAddress_SN


/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetAddress_Idx(long idx)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetAddress_Idx;
    // set parms ........................................................
    sndNmlPkg.basInf.idx = idx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_GetAddress_Idx

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetAddress_SN(char* SN, long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetAddress_SN;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    sndNmlPkg.prms.longs[0] = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetAddress_SN

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_AddressConflictExists(void)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_AddressConflictExists;
    // set parms ........................................................
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_AddressConflictExists

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_WillAddressConflict(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_WillAddressConflict;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_WillAddressConflict

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetSerNo_Addr(long addr, char* SN)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetSerNo_Addr;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    memcpy(SN,rcvNmlPkg.prms.sns.snOne,SERIAL_NUMBER_LEN);
    return rcvNmlPkg.basInf.result;
} // LB_GetSerNo_Addr

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_ChangeAddress(long currentAddr, long newAddr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_ChangeAddress;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = currentAddr;
    sndNmlPkg.prms.longs[0] = newAddr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_ChangeAddress

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetModelNumber_SN(char* SN, MODEL_NUMBER* modelNumber)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetModelNumber_SN;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *modelNumber = (MODEL_NUMBER)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetModelNumber_SN

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetModelNumber_Addr(long addr, MODEL_NUMBER* modelNumber)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetModelNumber_Addr;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *modelNumber = (MODEL_NUMBER)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetModelNumber_Addr

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_IsSensorConnected_SN(char* SN)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_IsSensorConnected_SN;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_IsSensorConnected_SN

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_IsSensorConnected_Addr(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_IsSensorConnected_Addr;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_IsSensorConnected_Addr;

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetAutoPulseEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetAutoPulseEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetAutoPulseEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetAutoPulseEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetAutoPulseEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} //LB_GetAutoPulseEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetCWReference(long addr, double relRef, PWR_UNITS units)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetCWReference;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = relRef;
    sndNmlPkg.prms.longs[0] = (long)units;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetCWReference

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetCWReference(long addr, double* relRef, PWR_UNITS* units)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetCWReference;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *relRef = rcvNmlPkg.prms.dbls[0];
    *units = (PWR_UNITS)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} //LB_GetCWReference

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetCurrentState(long addr, struct SensorState state)
//{
//	return ERR_UNK;
//} //LB_SetCurrentState

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetRegState(long addr, long regIdx, struct SensorState state)
//{
//	return ERR_UNK;
//}	// LB_SetRegState

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_GetCurrentState(long addr, struct SensorState* state)
//{
//	return ERR_UNK;
//}

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_GetRegState(long addr, long regIdx, struct SensorState* state)
//{
//	return ERR_UNK;
//}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetDoubleSidedLimit(long addr, double lowerVal, double upperVal, PWR_UNITS units, DS_RULE passFail)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetDoubleSidedLimit;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = lowerVal;
    sndNmlPkg.prms.dbls[1] = upperVal;
    sndNmlPkg.prms.longs[0] = (long)units;
    sndNmlPkg.prms.longs[1] = (long)passFail;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetDoubleSidedLimit(long addr, double* lowerVal, double* upperVal, PWR_UNITS* units, DS_RULE* passFail)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetDoubleSidedLimit;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *lowerVal = rcvNmlPkg.prms.dbls[0];
    *upperVal = rcvNmlPkg.prms.dbls[1];
    *units = (PWR_UNITS)rcvNmlPkg.prms.longs[0];
    *passFail = (DS_RULE)rcvNmlPkg.prms.longs[1];
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetDutyCycleEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetDutyCycleEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetDutyCycleEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetDutyCycleEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetDutyCyclePerCent(long addr, double val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetDutyCyclePerCent;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = val;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetDutyCyclePerCent(long addr, double* val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetDutyCyclePerCent;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *val = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetFirmwareVersion(long  addr, char* buff, long  buffLen)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetFirmwareVersion;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = buffLen;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    memcpy(buff,rcvNmlPkg.prms.sns.snOne,rcvNmlPkg.prms.longs[0]);
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetIndex_SN(char* SN)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetIndex_SN;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetIndex_Addr(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetIndex_Addr;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetLimitEnabled(long addr, LIMIT_STYLE lmtStyle)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetLimitEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)lmtStyle;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;

}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetLimitEnabled(long addr, LIMIT_STYLE* lmtStyle)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetLimitEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *lmtStyle = (LIMIT_STYLE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
}

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetMeasurementPowerUnits(long addr,PWR_UNITS units)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetMeasurementPowerUnits;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)units;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetMeasurementPowerUnits

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetMeasurementPowerUnits(long addr,PWR_UNITS* units)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetMeasurementPowerUnits;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *units = (PWR_UNITS)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetMeasurementPowerUnits

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetModelNumber_Idx(long idx, MODEL_NUMBER* modelNumber)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetModelNumber_Idx;
    // set parms ........................................................
    sndNmlPkg.basInf.idx = idx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *modelNumber = (MODEL_NUMBER)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
}	// LB_GetModelNumber_Idx

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetOffsetEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetOffsetEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}	// LB_SetOffsetEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetOffsetEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetOffsetEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetOffsetEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetPulseReference(long addr, 
										   double pulseRef, 
										   double peakRef, 
										   double averageRef, 
										   double dutyCycleRef, 
										   PWR_UNITS units)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetPulseReference;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = pulseRef;
    sndNmlPkg.prms.dbls[1] = peakRef;
    sndNmlPkg.prms.dbls[2] = averageRef;
    sndNmlPkg.prms.dbls[3] = dutyCycleRef;
    sndNmlPkg.prms.longs[0] = (long)units;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}  // LB_SetPulseReference

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetPulseReference(long addr, 
										   double* pulseRef, 
										   double* peakRef, 
										   double* averageRef, 
										   double* dutyCycleRef, 
										   PWR_UNITS* units)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetPulseReference;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
	*pulseRef = rcvNmlPkg.prms.dbls[0]; 
	*peakRef =  rcvNmlPkg.prms.dbls[1]; 
	*averageRef =  rcvNmlPkg.prms.dbls[2]; 
	*dutyCycleRef = rcvNmlPkg.prms.dbls[3]; 
	*units = (PWR_UNITS)rcvNmlPkg.prms.longs[0]; 
    return rcvNmlPkg.basInf.result;
} // LB_GetPulseReference

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetResponseEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetResponseEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetResponseEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetResponseEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetResponseEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetResponseEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetResponse(long addr, ResponsePoints* pts, long NumPts)
{
    ZeroRspPkgsNxtEvnt();
    // set call .........................................................
    sndRspPkg.basInf.callId = _LB_SetResponse;
    // set parms ........................................................
    sndRspPkg.basInf.addr = addr;
    sndRspPkg.rPts.cnt = NumPts;
    memcpy(sndRspPkg.rPts.pts, pts, sizeof(ResponsePoints) * NumPts);
    chPkg = (char *)&sndRspPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, RESPONSE_POINTS_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvRspPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, RESPONSE_POINTS_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvRspPkg.basInf.nEventId & sndRspPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvRspPkg.basInf.result;
} // LB_SetResponse

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetResponse_Flat(long addr, double* freq, double* amplitude, long NumPts)
{
    ZeroRspPkgsNxtEvnt();
    // set call .........................................................
    sndRspPkg.basInf.callId = _LB_SetResponse_Flat;
    // set parms ........................................................
    sndRspPkg.basInf.addr = addr;
    sndRspPkg.rPts.cnt = NumPts;
    memcpy(sndRspPkg.rPtsFlat.frequency, freq, sizeof(double) * NumPts);
    memcpy(sndRspPkg.rPtsFlat.amplitude, amplitude, sizeof(double) * NumPts);
    chPkg = (char *)&sndRspPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, RESPONSE_POINTS_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvRspPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, RESPONSE_POINTS_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvRspPkg.basInf.nEventId & sndRspPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvRspPkg.basInf.result;
} // LB_SetResponse_Flat

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetResponse(long addr, ResponsePoints* pts, long* NumPts)
{
    ZeroRspPkgsNxtEvnt();
    // set call .........................................................
    sndRspPkg.basInf.callId = _LB_GetResponse;
    // set parms ........................................................
    sndRspPkg.basInf.addr = addr;
    sndRspPkg.rPts.cnt = *NumPts;
    chPkg = (char *)&sndRspPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, RESPONSE_POINTS_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvRspPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, RESPONSE_POINTS_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvRspPkg.basInf.nEventId & sndRspPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *NumPts = rcvRspPkg.rPts.cnt;
    memcpy(pts, &rcvRspPkg.rPts.pts, sizeof(ResponsePoints) * sndRspPkg.rPts.cnt);
    return rcvRspPkg.basInf.result;
} // LB_GetResponse


/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetResponse_Flat(long addr, double* freq, double* amplitude, long* NumPts)
{
    ZeroRspPkgsNxtEvnt();
    // set call .........................................................
    sndRspPkg.basInf.callId = _LB_GetResponse_Flat;
    // set parms ........................................................
    sndRspPkg.basInf.addr = addr;
    chPkg = (char *)&sndRspPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, RESPONSE_POINTS_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvRspPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, RESPONSE_POINTS_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvRspPkg.basInf.nEventId & sndRspPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *NumPts = rcvRspPkg.rPts.cnt;
    memcpy(freq, &rcvRspPkg.rPtsFlat.frequency, sizeof(double) * sndRspPkg.rPtsFlat.cnt);
    memcpy(amplitude, &rcvRspPkg.rPtsFlat.amplitude, sizeof(double) * sndRspPkg.rPtsFlat.cnt);
    return rcvRspPkg.basInf.result;
} // LB_GetResponse_Flat

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetSerNo_Idx(long idx, char* SN)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetSerNo_Idx;
    // set parms ........................................................
    sndNmlPkg.basInf.idx = idx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    memcpy(SN,rcvNmlPkg.prms.sns.snOne,SERIAL_NUMBER_LEN);
    return rcvNmlPkg.basInf.result;
} // LB_GetSerNo_Idx

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetSerialNumber(long idx, long PW, char* SN)
//{
//	return ERR_UNK;
//} // LB_SetSerialNumber


/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetSingleSidedLimit(long addr, double val, PWR_UNITS units, SS_RULE passFail)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetSingleSidedLimit;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = val;
    sndNmlPkg.prms.longs[0] = (long)units;
    sndNmlPkg.prms.longs[1] = (long)passFail;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetSingleSidedLimit

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetSingleSidedLimit(long addr, double* val, PWR_UNITS* units, SS_RULE* passFail)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetSingleSidedLimit;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *val = rcvNmlPkg.prms.dbls[0];
    *units = (PWR_UNITS)rcvNmlPkg.prms.longs[0];
    *passFail = (SS_RULE)rcvNmlPkg.prms.longs[1];
    return rcvNmlPkg.basInf.result;
} // LB_GetSingleSidedLimit

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_InitializeSensor_Idx(long idx)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_InitializeSensor_Idx;
    // set parms ........................................................
    sndNmlPkg.basInf.idx = idx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_InitializeSensor_Idx

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_MeasureCW_PF(long addr, 
								double* CW, 
								PASS_FAIL_RESULT* PF)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_MeasureCW_PF;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *CW = rcvNmlPkg.prms.dbls[0];
    *PF = (PASS_FAIL_RESULT)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_MeasureCW_PF

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_MeasurePulse_PF(long addr, 
								double* pulse, 
								double* peak, 
								double* average, 
								double* dutyCycle, 
								PASS_FAIL_RESULT* PF)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_MeasurePulse_PF;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
	*pulse = rcvNmlPkg.prms.dbls[0];
	*peak = rcvNmlPkg.prms.dbls[1];
	*average = rcvNmlPkg.prms.dbls[2];
	*dutyCycle = rcvNmlPkg.prms.dbls[3];
	*PF = (PASS_FAIL_RESULT)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_MeasurePulse_PF

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_ReadStateFromINI(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_ReadStateFromINI;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_ReadStateFromINI

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_WriteStateToINI(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_WriteStateToINI;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_ReadStateFromINI

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_Recall(long addr, long regIdx)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_Recall;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = regIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_Recall

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_Store(long addr, long regIdx)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_Store;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = regIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_Store

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_ResetCurrentState(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_ResetCurrentState;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_ResetCurrentState

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_ResetRegStates(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_ResetRegStates;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_ResetRegStates

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetAddress_Idx(long idx, long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetAddress_Idx;
    // set parms ........................................................
    sndNmlPkg.basInf.idx = idx;
    sndNmlPkg.prms.longs[0] = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetAddress_Idx

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetOffset(long addr, double val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetOffset;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = val;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetOffset

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetOffset(long addr, double* val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetOffset;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *val = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetOffset


/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetCalDueDate(char* SN, long lngYear, long lngMonth, long lngDay)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetCalDueDate;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    sndNmlPkg.prms.longs[0] = lngYear;
    sndNmlPkg.prms.longs[1] = lngMonth;
    sndNmlPkg.prms.longs[2] = lngDay;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetCalDueDate

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetCalDueDate(char* SN, long* year, long* month, long* day)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetCalDueDate;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *year = rcvNmlPkg.prms.longs[0];
    *month = rcvNmlPkg.prms.longs[1];
    *day = rcvNmlPkg.prms.longs[2];
    return rcvNmlPkg.basInf.result;
} // LB_GetCalDueDate

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetModelNumber(char* SN, long PW, MODEL_NUMBER modelNumber)
//{
//	return ERR_UNK;
//} // LB_SetModelNumber

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetCalOptExpDate(char* SN, long PW, long lngYear, long lngMonth, long lngDay)
//{
//	return ERR_UNK;
//} // LB_SetCalOptExpDate

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetCalOptExpDate(char* SN, long* year, long* month, long* day)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetCalOptExpDate;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *year = rcvNmlPkg.prms.longs[0];
    *month = rcvNmlPkg.prms.longs[1];
    *day = rcvNmlPkg.prms.longs[2];
    return rcvNmlPkg.basInf.result;
} // LB_GetCalOptExpDate

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetWtyOptExpDate(char* SN, long PW, long lngYear, long lngMonth, long lngDay)
//{
//	return ERR_UNK;
//} // LB_SetWtyOptExpDate

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetWtyOptExpDate(char* SN, long* year, long* month, long* day)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetWtyOptExpDate;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *year = rcvNmlPkg.prms.longs[0];
    *month = rcvNmlPkg.prms.longs[1];
    *day = rcvNmlPkg.prms.longs[2];
    return rcvNmlPkg.basInf.result;
} // LB_GetCalOptExpDate

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetConnectorOption(char* SN, long PW, long optVal)
//{
//	return ERR_UNK;
//} // LB_SetConnectorOption

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_GetConnectorOption(char* SN, long* val)
//{
//	return ERR_UNK;
//} // LB_GetConnectorOption

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetCalAndWtyOption(char* SN, long  PW, long  optVal)
//{
//	return ERR_UNK;
//} // LB_SetCalAndWtyOption

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetCalAndWtyOption(char* SN, long* val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetCalAndWtyOption;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *val = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetCalAndWtyOption

/*=======================================================================

-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetRecorderOutOption(char* SN, long PW, long optVal)
//{
//
//	return ERR_UNK;
//} // LB_SetRecorderOutOption

/*=======================================================================

-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetRecorderOutOption(char* SN, long* val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetRecorderOutOption;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *val = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetRecorderOutOption

/*=======================================================================

-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetBestMatchOpt(char* SN, long PW, long optVal)
//{
//	return ERR_UNK;
//} // LB_SetBestMatchOpt

/*=======================================================================

-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetBestMatchOpt(char* SN, long* val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetBestMatchOpt;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *val = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetBestMatchOpt

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetTriggerOpt(char* SN, long PW, long optVal)
//{
//	return ERR_UNK;
//} // LB_SetTriggerOpt

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetTriggerOpt(char* SN, long* val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetTriggerOpt;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *val = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetTriggerOpt

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetFilterOpt(char* SN, long PW, long optVal)
//{
//	return ERR_UNK;
//} // LB_SetFilterOpt

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetFilterOpt(char* SN, long* val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetFilterOpt;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *val = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetFilterOpt

/*=======================================================================

----------------------------------------------------------------------*/
LB_API2_32_64_API LB_InitializeSensor_SN(char* SN)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_InitializeSensor_SN;
    // set parms ........................................................
    memcpy(sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_InitializeSensor_SN

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_UninitializeSensor_SN(char* SN)
//{
//	return ERR_UNK;
//} // LB_UninitializeSensor_SN

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_InitializeSensor_Addr(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_InitializeSensor_Addr;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_InitializeSensor_Addr

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetFrequency(long addr, double* value)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetFrequency;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *value = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetFrequency

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetFrequency(long addr, double value)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetFrequency;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = value;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetFrequency

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetAverages(long addr, long* value)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetAverages;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *value = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetAverages

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetAverages(long addr, long value)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetAverages;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = value;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetAverages

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetPulseCriteria(long addr, double* value)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetPulseCriteria;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *value = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetPulseCriteria

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetPulseCriteria(long addr, double value)			
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetPulseCriteria;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = value;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetPulseCriteria

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetTTLTriggerInEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetTTLTriggerInEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetTTLTriggerInEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetTTLTriggerInEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetTTLTriggerInEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetTTLTriggerInEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetTTLTriggerInInverted(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetTTLTriggerInInverted;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetTTLTriggerInInverted

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetTTLTriggerInInverted(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetTTLTriggerInInverted;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetTTLTriggerInInverted

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetTTLTriggerInTimeOut(long addr, long* val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetTTLTriggerInTimeOut;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *val = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetTTLTriggerInTimeOut

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetTTLTriggerInTimeOut(long addr, long val)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetTTLTriggerInTimeOut;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = val;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetTTLTriggerInTimeOut

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetTTLTriggerOutEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetTTLTriggerOutEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetTTLTriggerOutEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetTTLTriggerOutEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetTTLTriggerOutEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetTTLTriggerOutEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetTTLTriggerOutInverted(long addr, FEATURE_STATE *st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetTTLTriggerOutInverted;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetTTLTriggerOutInverted

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetTTLTriggerOutInverted(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetTTLTriggerOutInverted;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetTTLTriggerOutInverted

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetAntiAliasingEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetAntiAliasingEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetAntiAliasingEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetAntiAliasingEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetAntiAliasingEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetAntiAliasingEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_GetRecorderOutEnabled(long addr, FEATURE_STATE* st)
//{
//	return ERR_UNK;
//} // LB_GetRecorderOutEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetRecorderOutEnabled(long addr, FEATURE_STATE st)
//{
//	return ERR_UNK;
//} // LB_SetRecorderOutEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_GetRecorderOutSetup(long addr, double* val_0_V, double* val_1_V, PWR_UNITS* units)
//{
//	return ERR_UNK;
//} // LB_GetRecorderOutSetup

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_SetRecorderOutSetup(long addr, double val_0_V, double val_1_V, PWR_UNITS units)
//{
//	return ERR_UNK;
//} // LB_SetRecorderOutSetup

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
LB_API2_32_64_API LB_MeasureCW(long addr, double* CW)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_MeasureCW;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *CW = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // LB_MeasureCW

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
LB_API2_32_64_API LB_MeasurePulse(long addr, double* pulse, double* peak, double* average, double* dutyCycle)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_MeasurePulse;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *pulse = rcvNmlPkg.prms.dbls[0];
    *peak = rcvNmlPkg.prms.dbls[1];
    *average = rcvNmlPkg.prms.dbls[2];
    *dutyCycle = rcvNmlPkg.prms.dbls[3];
    return rcvNmlPkg.basInf.result;
} // LB_MeasurePulse

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_ReInit_Addr(long addr)
//{
//	return ERR_UNK;
//}  // LB_ReInit_Addr

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API LB_ReInit_Idx(long idx)
//{
//	return ERR_UNK;
//}  // LB_ReInit_Idx

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetExtendedAveragingEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetExtendedAveragingEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetExtendedAveragingEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetExtendedAveragingEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetExtendedAveragingEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetExtendedAveragingEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetExtendedAveraging(long addr, long* extAvg)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetExtendedAveraging;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *extAvg = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetExtendedAveraging

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetExtendedAveraging(long addr, long extAvg)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetExtendedAveraging;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = extAvg;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetExtendedAveraging

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_ResetExtendedAveraging(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_ResetExtendedAveraging;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_ResetExtendedAveraging

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_GetMaxHoldEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_GetMaxHoldEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_GetMaxHoldEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_SetMaxHoldEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_SetMaxHoldEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_SetMaxHoldEnabled

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_ResetMaxHold(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_ResetMaxHold;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_ResetMaxHold

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_Get75OhmsEnabled(long addr, FEATURE_STATE* st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_Get75OhmsEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *st = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // LB_ResetMaxHold

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API LB_Set75OhmsEnabled(long addr, FEATURE_STATE st)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_Set75OhmsEnabled;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)st;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // LB_ResetMaxHold

//=============================================================================
//-----------------------------------------------------------------------------
//LB_API2_32_64_API LB_IsDeviceInUse_Idx(long idx)
//{
//	return ERR_UNK;
//} // LB_SensorCnt

//=============================================================================
//-----------------------------------------------------------------------------
LB_API2_32_64_API LB_IsDeviceInUse_Addr(long addr)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_IsDeviceInUse_Addr;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}

//=============================================================================
//-----------------------------------------------------------------------------
LB_API2_32_64_API LB_IsDeviceInUse_SN(char* SN)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_IsDeviceInUse_SN;
    // set parms ........................................................
    memcpy( sndNmlPkg.basInf.sn,SN,SERIAL_NUMBER_LEN);
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
}

//=============================================================================
//-----------------------------------------------------------------------------
//LB_API2_32_64_API LB_SaveCurrStateTo(long addr, char* stateName)
//{
//	return ERR_UNK;
//}

//=============================================================================
//-----------------------------------------------------------------------------
//LB_API2_32_64_API LB_RestoreCurrStateFrom(long addr, char* stateName)
//{
//	return ERR_UNK;
//}

//=============================================================================
//-----------------------------------------------------------------------------
//LB_API2_32_64_API LB_GetNamedStateCount(long addr)
//{
//	return ERR_UNK;
//}

//=============================================================================
//-----------------------------------------------------------------------------
//LB_API2_32_64_API LB_GetNamedStateNames(long addr, char* names, long *cnt)
//{
//	return ERR_UNK;
//}

//=============================================================================
//-----------------------------------------------------------------------------
//LB_API2_32_64_API LB_DeleteNamedState(long addr, char* name)
//{
//	return ERR_UNK;
//}

//=============================================================================
// Name: LB_MeasureBurst_DBM
//-----------------------------------------------------------------------------
LB_API2_32_64_API LB_MeasureBurst_DBM(long addr, long delayUSEC, long measTimeUSEC, long trgInt, double* pk, double *avg, double *min)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_MeasureBurst_DBM;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = delayUSEC;
    sndNmlPkg.prms.longs[1] = measTimeUSEC;
    sndNmlPkg.prms.longs[2] = trgInt;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *pk = rcvNmlPkg.prms.dbls[0];
    *avg = rcvNmlPkg.prms.dbls[1];
    *min = rcvNmlPkg.prms.dbls[2];
    return rcvNmlPkg.basInf.result;
} // LB_MeasureBurst_DBM

LB_API2_32_64_API LB_CloseRestartSocketServerSocket(void)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _LB_CloseRestartSocketServerSocket;
    // set parms ........................................................
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    return 1;
}



// PP PP PP PP PP PP PP PP PP PP PP PP PP PP PP PP PP PP PP PP PP PP PP
/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetSweepTime(long addr, long SwpTm)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetSweepTime;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = SwpTm;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetSweepTime

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetSweepTime(long addr, long* SwpTm)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetSweepTime;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *SwpTm = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetSweepTime

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetSweepDelay(long addr, long SwpDly)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetSweepDelay;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = SwpDly;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetSweepDelay

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetSweepDelay(long addr, long* SwpDly)
{
    ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetSweepDelay;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *SwpDly = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetSweepDelay

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetSweepDelayMode(long addr, long SwpDlyMode)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetSweepDelayMode;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = SwpDlyMode;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetSweepDelayMode

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetSweepDelayMode(long addr, long* SwpDlyMode)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetSweepDelayMode;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *SwpDlyMode = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetSweepDelayMode

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetSweepHoldOff(long addr, long SwpHOff)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetSweepHoldOff;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = SwpHOff;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetSweepHoldOff

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetSweepHoldOff(long addr, long* SwpHOff)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetSweepHoldOff;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *SwpHOff = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetSweepHoldOff

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetFilter(long addr, FLT_CO_FREQ fltrIdx)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetFilter;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)fltrIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetFilter

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetFilter(long addr, FLT_CO_FREQ* fltrIdx)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetFilter;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *fltrIdx = (FLT_CO_FREQ)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetFilter

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetTriggerSoure(long addr, TRIGGER_SOURCE TrgSrc)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetTriggerSoure;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)TrgSrc;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetTriggerSoure

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetTriggerSoure(long addr, TRIGGER_SOURCE* TrgSrc)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetTriggerSoure;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *TrgSrc = (TRIGGER_SOURCE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetTriggerSoure

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetTriggerLevel(long addr, double TrgLvl)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetTriggerLevel;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = TrgLvl;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetTriggerLevel

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetTriggerLevel(long addr, double* TrgLvl)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetTriggerLevel;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *TrgLvl = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetTriggerLevel

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetTriggerEdge(long addr, TRIGGER_EDGE TrgEdge)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetTriggerEdge;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)TrgEdge;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetTriggerEdge

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetTriggerEdge(long addr, TRIGGER_EDGE* TrgEdge)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetTriggerEdge;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *TrgEdge = (TRIGGER_EDGE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetTriggerEdge

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API PP_CheckTrigger(long addr)
//{
//	ZeroNmlPkgsNxtEvnt();
//    // set call .........................................................
//    sndNmlPkg.basInf.callId = _PP_CheckTrigger;
//    // set parms ........................................................
//    sndNmlPkg.basInf.addr = addr;
//    chPkg = (char *)&sndNmlPkg;
//    // snd package ......................................................
//    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
//    if (rslt <= 0) return ERR_UNK;
//    chPkg = (char *)&rcvNmlPkg;
//    // rcv package ......................................................
//    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
//    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
//    // get parms ........................................................
//    return rcvNmlPkg.basInf.result;
//} // PP_CheckTrigger

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetTraceLength(long addr)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetTraceLength;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_GetTraceLength

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetAnalysisTraceLength(long addr)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetAnalysisTraceLength;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_GetAnalysisTraceLength

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_AnalysisTraceIsValid(long  addr)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_AnalysisTraceIsValid;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_AnalysisTraceIsValid

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetTrace(long addr, double *tr, long trLen, long* trUsed)
{ // SAR - FIX - ??? - TODO
	ZeroTrcPkgsNxtEvnt();
    // set call .........................................................
    sndTrcPkg.basInf.callId = _PP_GetTrace;
    // set parms ........................................................
    sndTrcPkg.basInf.addr = addr;
    sndTrcPkg.prms.longs[0] = trLen;
    chPkg = (char *)&sndTrcPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, TRACE_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvTrcPkg;
    // rcv package ......................................................
	if (client.Recv(chPkg, TRACE_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvTrcPkg.basInf.nEventId & sndTrcPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    memcpy(tr, rcvTrcPkg.prms.traceOut, sizeof(double) * trLen);
    *trUsed = rcvTrcPkg.prms.longs[1];
    return rcvTrcPkg.basInf.result;
} // PP_GetTrace

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API PP_AcquireTrace(long addr)
//{
//	ZeroNmlPkgsNxtEvnt();
//    // set call .........................................................
//    sndNmlPkg.basInf.callId = _PP_AcquireTrace;
//    // set parms ........................................................
//    sndNmlPkg.basInf.addr = addr;
//    chPkg = (char *)&sndNmlPkg;
//    // snd package ......................................................
//    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
//    if (rslt <= 0) return ERR_UNK;
//    chPkg = (char *)&rcvNmlPkg;
//    // rcv package ......................................................
//    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
//    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
//    // get parms ........................................................
//    return rcvNmlPkg.basInf.result;
//} // PP_AcquireTrace

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_CnvtTrace(long addr, double* trIn, long trLen, double* trOut, long pwrUnitsIn, long pwrUnitsOut)
{ // SAR - FIX - ??? - TODO
	ZeroTrcPkgsNxtEvnt();
    // set call .........................................................
    sndTrcPkg.basInf.callId = _PP_CnvtTrace;
    // set parms ........................................................
    sndTrcPkg.basInf.addr = addr;
	memcpy(sndTrcPkg.prms.traceIn, trIn, sizeof(double) * trLen);
    sndTrcPkg.prms.longs[0] = trLen;
    sndTrcPkg.prms.longs[1] = pwrUnitsIn;
    sndTrcPkg.prms.longs[2] = pwrUnitsOut;
    chPkg = (char *)&sndTrcPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, TRACE_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvTrcPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, TRACE_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvTrcPkg.basInf.nEventId & sndTrcPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
	memcpy(trOut, rcvTrcPkg.prms.traceOut, sizeof(double) * trLen);
    return rcvTrcPkg.basInf.result;
} // PP_CnvtTrace

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_CurrTrace2AnalysisTrace(long addr, double*tr, long trLen)
{ // SAR - FIX - ??? - TODO
	ZeroTrcPkgsNxtEvnt();
    // set call .........................................................
    sndTrcPkg.basInf.callId = _PP_CurrTrace2AnalysisTrace;
    // set parms ........................................................
    sndTrcPkg.basInf.addr = addr;
    sndTrcPkg.prms.longs[0] = trLen;
    chPkg = (char *)&sndTrcPkg;
    // snd package ......................................................
	rslt = client.Send(chPkg, TRACE_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvTrcPkg;
    // rcv package ......................................................
	if (client.Recv(chPkg, TRACE_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvTrcPkg.basInf.nEventId & sndTrcPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    memcpy(tr, rcvTrcPkg.prms.traceOut, sizeof(double) * trLen);
    return rcvTrcPkg.basInf.result;
} // PP_CurrTrace2AnalysisTrace

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetGateMode(long addr, long gateIdx, GATE_MODE mode)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetGateMode;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    sndNmlPkg.prms.longs[1] = (long)mode;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetGateMode

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetGateMode(long addr, long gateIdx, GATE_MODE* mode)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetGateMode;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
	*mode = (GATE_MODE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetGateMode

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetGateStartEndPosition(long addr, long gateIdx, long trSttIdx, long trEndIdx)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetGateStartEndPosition;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    sndNmlPkg.prms.longs[1] = trSttIdx;
    sndNmlPkg.prms.longs[2] = trEndIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetGateStartEndPosition

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetGateStartEndPosition(long addr, long gateIdx, long* trSttIdx, long* trEndIdx)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetGateStartEndPosition;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *trSttIdx = rcvNmlPkg.prms.longs[1];
    *trEndIdx = rcvNmlPkg.prms.longs[2];
    return rcvNmlPkg.basInf.result;
} // PP_GetGateStartEndPosition

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetGateStartPosition(long addr, long gateIdx, long trIdx)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetGateStartPosition;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    sndNmlPkg.prms.longs[1] = trIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetGateStartPosition

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetGateStartPosition(long addr, long gateIdx, long* trIdx)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetGateStartPosition;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *trIdx = rcvNmlPkg.prms.longs[1];
    return rcvNmlPkg.basInf.result;
} // PP_GetGateStartPosition

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetGateEndPosition(long addr, long gateIdx, long trIdx)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetGateEndPosition;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    sndNmlPkg.prms.longs[1] = trIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetGateEndPosition

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetGateEndPosition(long addr, long gateIdx, long* trIdx)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetGateEndPosition;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *trIdx = rcvNmlPkg.prms.longs[1];
    return rcvNmlPkg.basInf.result;
} // PP_GetGateEndPosition

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API PP_GetGateStartEndPositionTime(long addr, long gateIdx, long* sttIdx, double* sttTm, long* endIdx, double* endTm)
//{
//	ZeroNmlPkgsNxtEvnt();
//    // set call .........................................................
//    sndNmlPkg.basInf.callId = _PP_GetGateStartEndPositionTime;
//    // set parms ........................................................
//    sndNmlPkg.basInf.addr = addr;
//    sndNmlPkg.prms.longs[0] = gateIdx;
//    chPkg = (char *)&sndNmlPkg;
//    // snd package ......................................................
//    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
//    if (rslt <= 0) return ERR_UNK;
//    chPkg = (char *)&rcvNmlPkg;
//    // rcv package ......................................................
//    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
//    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
//    // get parms ........................................................
//    *sttIdx = rcvNmlPkg.prms.longs[1];
//    *sttTm = rcvNmlPkg.prms.dbls[0];
//    *endIdx = rcvNmlPkg.prms.longs[2];
//    *endTm = rcvNmlPkg.prms.dbls[1];
//    return rcvNmlPkg.basInf.result;
//} // PP_GetGateStartEndPositionTime

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GatePositionIsValid(long addr, long gateIdx, long* valid)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GatePositionIsValid;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *valid = rcvNmlPkg.prms.longs[1];
    return rcvNmlPkg.basInf.result;
} // PP_GatePositionIsValid

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetGateStartEndTime(long addr, long gateIdx, double gateSttTm, double gateEndTm)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetGateStartEndTime;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    sndNmlPkg.prms.dbls[0] = gateSttTm;
    sndNmlPkg.prms.dbls[1] = gateEndTm;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetGateStartEndTime

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetGateStartEndTime(long addr, long gateIdx, double* gateSttTm, double* gateEndTm)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetGateStartEndTime;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *gateSttTm = rcvNmlPkg.prms.dbls[0];
    *gateEndTm = rcvNmlPkg.prms.dbls[1];
    return rcvNmlPkg.basInf.result;
} // PP_GetGateStartEndTime

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetGateStartTime(long addr, long gateIdx, double gateTm)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetGateStartTime;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    sndNmlPkg.prms.dbls[0] = gateTm;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetGateStartTime

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetGateStartTime(long addr, long gateIdx, double* gateTm)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetGateStartTime;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *gateTm = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetGateStartTime

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetGateEndTime(long addr, long gateIdx, double gateTm)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetGateEndTime;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    sndNmlPkg.prms.dbls[0] = gateTm;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetGateEndTime

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetGateEndTime(long addr, long gateIdx, double* gateTm)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetGateEndTime;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *gateTm = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetGateEndTime

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetGateAveragePower(long addr, long gateIdx, double* avgPwr)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetGateAveragePower;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *avgPwr = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetGateAveragePower

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetGatePeakPower(long addr, long gateIdx, double* pkPwr)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetGatePeakPower;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *pkPwr = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetGatePeakPower

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetGateCrestFactor(long addr, long gateIdx, double* crFactor)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetGateCrestFactor;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *crFactor = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetGateCrestFactor

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetGateDroop(long addr, long gateIdx, double* droop)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetGateDroop;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *droop = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetGateDroop

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetGateRiseTime(long addr, long gateIdx, double* riseTm)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetGateRiseTime;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *riseTm = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetGateRiseTime

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetGatePulseWidth(long addr, long gateIdx, double* plsWidth)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetGatePulseWidth;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *plsWidth = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetGatePulseWidth

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetGatePulsePower(long addr, long gateIdx, double* plsPwr)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetGatePulsePower;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *plsPwr = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetGatePulsePower

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetGateFallTime(long addr, long gateIdx, double* fallTm)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetGateFallTime;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *fallTm = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetGateFallTime

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetGateOverShoot(long addr, long gateIdx, double* overShoot)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetGateOverShoot;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *overShoot = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetGateOverShoot

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetGateDutyCycle(long addr, long gateIdx, double* dutyCycle)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetGateDutyCycle;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *dutyCycle = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetGateDutyCycle

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetGatePRF(long addr, long gateIdx, double* PRFreq)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetGatePRF;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *PRFreq = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetGatePRF

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetGatePRT(long addr, long gateIdx, double* PRTime)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetGatePRT;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = gateIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *PRTime = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetGatePRT

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetAvgMode(long addr, AVG_MODE mode)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetAvgMode;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)mode;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetAvgMode

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetAvgMode(long addr, AVG_MODE *mode)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetAvgMode;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
	*mode = (AVG_MODE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetAvgMode

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetTraceAvgs(long addr, long averages)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetTraceAvgs;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = averages;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetTraceAvgs

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetTraceAvgs(long addr, long* averages)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetTraceAvgs;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *averages = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetTraceAvgs

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetAvgResetSens(long addr, double sensitivity)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetAvgResetSens;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = sensitivity;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetAvgResetSens

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetAvgResetSens(long addr, double* sensitivity)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetAvgResetSens;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *sensitivity = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetAvgResetSens

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetMarkerMode(long addr, long mrkIdx, MARKER_MODE mode)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetMarkerMode;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = mrkIdx;
    sndNmlPkg.prms.longs[1] = (long)mode;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetMarkerMode

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetMarkerMode(long addr, long mrkIdx, MARKER_MODE* mode)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetMarkerMode;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = mrkIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *mode = (MARKER_MODE)rcvNmlPkg.prms.longs[1];
    return rcvNmlPkg.basInf.result;
} // PP_GetMarkerMode

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetMarkerPosition(long addr, long mrkIdx, long trIdx)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetMarkerPosition;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = mrkIdx;
    sndNmlPkg.prms.longs[1] = trIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetMarkerPosition

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetMarkerPosition(long addr, long mrkIdx, long* trIdx)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetMarkerPosition;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = mrkIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *trIdx = rcvNmlPkg.prms.longs[1];
    return rcvNmlPkg.basInf.result;
} // PP_GetMarkerPosition

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetMarkerAmp(long addr, long mrkIdx, double* mkrAmp)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetMarkerAmp;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = mrkIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *mkrAmp = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetMarkerAmp

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetMarkerPositionTime(long addr, long mrkIdx, double mkrTm)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetMarkerPositionTime;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = mrkIdx;
    sndNmlPkg.prms.dbls[0] = mkrTm;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetMarkerPositionTime

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetMarkerPositionTime(long addr, long mrkIdx, double* mkrTm)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetMarkerPositionTime;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = mrkIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *mkrTm = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetMarkerPositionTime

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_MarkerPosIsValid(long addr, long mrkIdx, long* valid)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_MarkerPosIsValid;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = mrkIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *valid = rcvNmlPkg.prms.longs[1];
    return rcvNmlPkg.basInf.result;
} // PP_MarkerPosIsValid

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_MarkerToPk(long addr, long mrkIdx)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_MarkerToPk;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = mrkIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_MarkerToPk

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_MarkerToLowestPk(long addr, long mrkIdx)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_MarkerToLowestPk;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = mrkIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_MarkerToLowestPk

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_MarkerPkLower(long addr, long mrkIdx)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_MarkerPkLower;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = mrkIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_MarkerPkLower

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_MarkerPkHigher(long addr, long mrkIdx)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_MarkerPkHigher;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = mrkIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_MarkerPkHigher

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_MarkerToFirstPk(long addr, long mrkIdx)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_MarkerToFirstPk;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = mrkIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_MarkerToFirstPk

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_MarkerToLastPk(long addr, long mrkIdx)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_MarkerToLastPk;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = mrkIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_MarkerToLastPk

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_MarkerPrevPk(long addr, long mrkIdx)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_MarkerPrevPk;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = mrkIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_MarkerPrevPk

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_MarkerNextPk(long addr, long mrkIdx)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_MarkerNextPk;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = mrkIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_MarkerNextPk

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetMarkerDeltaTime(long addr, long mrkIdx, double mkrTm)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetMarkerDeltaTime;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = mrkIdx;
    sndNmlPkg.prms.dbls[0] = mkrTm;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetMarkerDeltaTime

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetMarkerDeltaTime(long addr, long mrkIdx, double* mkrTm)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetMarkerDeltaTime;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = mrkIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *mkrTm = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetMarkerDeltaTime

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetPeaks_Idx(long addr, Peak* peaks, long maxPks, long* pksUsed)
{ // SAR - FIX - ??? - TODO
	ZeroTrcPkgsNxtEvnt();
    // set call .........................................................
    sndTrcPkg.basInf.callId = _PP_GetPeaks_Idx;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndTrcPkg.prms.longs[0] = maxPks;
    chPkg = (char *)&sndTrcPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, TRACE_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvTrcPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, TRACE_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvTrcPkg.basInf.nEventId & sndTrcPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
	memcpy(peaks, rcvTrcPkg.prms.peaks, sizeof(Peak) * rcvTrcPkg.prms.longs[1]);
    *pksUsed = rcvTrcPkg.prms.longs[1];
    return rcvTrcPkg.basInf.result;
} // PP_GetPeaks_Idx

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetPeaks_Val(long addr, struct Peak* peaks, long maxPks, long* pksUsed)
{ // SAR - FIX - ??? - TODO
	ZeroTrcPkgsNxtEvnt();
    // set call .........................................................
    sndTrcPkg.basInf.callId = _PP_GetPeaks_Val;
    // set parms ........................................................
    sndTrcPkg.basInf.addr = addr;
    sndTrcPkg.prms.longs[0] = maxPks;
    chPkg = (char *)&sndTrcPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, TRACE_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvTrcPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, TRACE_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvTrcPkg.basInf.nEventId & sndTrcPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
	memcpy(peaks, rcvTrcPkg.prms.peaks, sizeof(Peak) * rcvTrcPkg.prms.longs[1]);
    *pksUsed = rcvTrcPkg.prms.longs[1];
    return rcvTrcPkg.basInf.result;
} // PP_GetPeaks_Val

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetPeaks_VEE_Idx(long addr, long* pkIndicies, double* pkValues, long maxPks, long* pksUsed)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetPeaks_VEE_Idx;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[1] = maxPks;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *pkIndicies	 = rcvNmlPkg.prms.longs[0];
    *pkValues	 = rcvNmlPkg.prms.dbls[0];
    *pksUsed	 = rcvNmlPkg.prms.longs[2];
    return rcvNmlPkg.basInf.result;
} // PP_GetPeaks_VEE_Idx

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetPeaks_VEE_Val(long addr, long* pkIndicies, double* pkValues, long maxPks, long* pksUsed)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetPeaks_VEE_Val;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[1] = maxPks;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *pkIndicies	 = rcvNmlPkg.prms.longs[0];
    *pkValues	 = rcvNmlPkg.prms.dbls[0];
    *pksUsed	 = rcvNmlPkg.prms.longs[2];
    return rcvNmlPkg.basInf.result;
} // PP_GetPeaks_VEE_Val

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API PP_GetPeaks_Idx_Flat(long addr, long* pkIndicies, double* pkValues, long maxPks,long* pksUsed)
//{
//	ZeroNmlPkgsNxtEvnt();
//    // set call .........................................................
//    sndNmlPkg.basInf.callId = _PP_GetPeaks_Idx_Flat;
//    // set parms ........................................................
//    sndNmlPkg.basInf.addr = addr;
//    sndNmlPkg.prms.longs[1] = maxPks;
//    chPkg = (char *)&sndNmlPkg;
//    // snd package ......................................................
//    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
//    if (rslt <= 0) return ERR_UNK;
//    chPkg = (char *)&rcvNmlPkg;
//    // rcv package ......................................................
//    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
//    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
//    // get parms ........................................................
//    *pkIndicies = rcvNmlPkg.prms.longs[0];
//    *pkValues = rcvNmlPkg.prms.dbls[0];
//    *pksUsed = rcvNmlPkg.prms.longs[2];
//    return rcvNmlPkg.basInf.result;
//} // PP_GetPeaks_Idx_Flat

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API PP_GetPeaks_Val_Flat(long addr, long* pkIndicies, double* pkValues, long maxPks,long* pksUsed)
//{
//	ZeroNmlPkgsNxtEvnt();
//    // set call .........................................................
//    sndNmlPkg.basInf.callId = _PP_GetPeaks_Val_Flat;
//    // set parms ........................................................
//    sndNmlPkg.basInf.addr = addr;
//    sndNmlPkg.prms.longs[1] = maxPks;
//    chPkg = (char *)&sndNmlPkg;
//    // snd package ......................................................
//    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
//    if (rslt <= 0) return ERR_UNK;
//    chPkg = (char *)&rcvNmlPkg;
//    // rcv package ......................................................
//    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
//    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
//    // get parms ........................................................
//    *pkIndicies = rcvNmlPkg.prms.longs[0];
//    *pkValues = rcvNmlPkg.prms.dbls[0];
//    *pksUsed = rcvNmlPkg.prms.longs[2];
//    return rcvNmlPkg.basInf.result;
//} // PP_GetPeaks_Val_Flat

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetPeaksFromTr_Idx(double* tr ,long trLen, long units, double peakCrit, double measThresh, struct Peak* peaks, long maxPks, long* pksUsed)
{ // SAR - FIX - ??? - TODO
	ZeroTrcPkgsNxtEvnt();
    // set call .........................................................
    sndTrcPkg.basInf.callId = _PP_GetPeaksFromTr_Idx;
    // set parms ........................................................
    //sndTrcPkg.basInf.addr = addr;
	memcpy(sndTrcPkg.prms.traceIn, tr, sizeof(double) * trLen);
    sndTrcPkg.prms.longs[0] = trLen;
    sndTrcPkg.prms.longs[1] = units;
    sndTrcPkg.prms.dbls[0] = peakCrit;
    sndTrcPkg.prms.dbls[1] = measThresh;
    sndTrcPkg.prms.longs[2] = maxPks;
    chPkg = (char *)&sndTrcPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, TRACE_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvTrcPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, TRACE_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvTrcPkg.basInf.nEventId & sndTrcPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
	memcpy(peaks, rcvTrcPkg.prms.peaks, sizeof(Peak) * rcvTrcPkg.prms.longs[3]);
    *pksUsed = rcvTrcPkg.prms.longs[3];
    return rcvTrcPkg.basInf.result;
} // PP_GetPeaksFromTr_Idx

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetPeaksFromTr_Val(double* tr, long trLen, long units, double peakCrit, double measThresh, struct Peak* peaks, long maxPks, long* pksUsed)
{ // SAR - FIX - ??? - TODO
	ZeroTrcPkgsNxtEvnt();
    // set call .........................................................
    sndTrcPkg.basInf.callId = _PP_GetPeaksFromTr_Val;
    // set parms ........................................................
//    sndTrcPkg.basInf.addr = addr;
	memcpy(sndTrcPkg.prms.traceIn, tr, sizeof(double) * trLen);
    sndTrcPkg.prms.longs[0] = trLen;
    sndTrcPkg.prms.longs[1] = units;
    sndTrcPkg.prms.dbls[0] = peakCrit;
    sndTrcPkg.prms.dbls[1] = measThresh;
    sndTrcPkg.prms.longs[2] = maxPks;
    chPkg = (char *)&sndTrcPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, TRACE_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvTrcPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, TRACE_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvTrcPkg.basInf.nEventId & sndTrcPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
	memcpy(peaks, rcvTrcPkg.prms.peaks, sizeof(Peak) * rcvTrcPkg.prms.longs[3]);
    *pksUsed = rcvTrcPkg.prms.longs[3];
    return rcvTrcPkg.basInf.result;
} // PP_GetPeaksFromTr_Val

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetMeasurementThreshold(long addr, double measThreshold_dBm)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetMeasurementThreshold;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = measThreshold_dBm;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetMeasurementThreshold

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetMeasurementThreshold(long addr, double* measThreshold_dBm)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetMeasurementThreshold;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *measThreshold_dBm = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetMeasurementThreshold

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetMarkerDeltaAmp(long addr, long mrkIdx, double* deltaMkrAmp)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetMarkerDeltaAmp;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = mrkIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *deltaMkrAmp = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetMarkerDeltaAmp

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetAnalysisTrace(long addr, double frequency, double sweepTime, double*tr, long trLen, PWR_UNITS units)
{ // SAR - FIX - ??? - TODO
	ZeroTrcPkgsNxtEvnt();
    // set call .........................................................
    sndTrcPkg.basInf.callId = _PP_SetAnalysisTrace;
    // set parms ........................................................
    sndTrcPkg.basInf.addr = addr;
    sndTrcPkg.prms.dbls[0] = frequency;
    sndTrcPkg.prms.dbls[1] = sweepTime;
    memcpy(sndTrcPkg.prms.traceIn, tr, sizeof(double) * trLen);
    sndTrcPkg.prms.longs[0] = trLen;
    sndTrcPkg.prms.longs[1] = (long)units;
    chPkg = (char *)&sndTrcPkg;
    // snd package ......................................................
	rslt = client.Send(chPkg, TRACE_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvTrcPkg;
    // rcv package ......................................................
	if (client.Recv(chPkg, TRACE_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvTrcPkg.basInf.nEventId & sndTrcPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvTrcPkg.basInf.result;
} // PP_SetAnalysisTrace

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetPoles(long addr, FLT_POLES fltrPoles)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetPoles;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)fltrPoles;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetPoles

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetPoles(long addr, FLT_POLES* fltrPoles)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetPoles;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *fltrPoles = (FLT_POLES)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetPoles

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API PP_SetState(long addr)
//{
//	ZeroNmlPkgsNxtEvnt();
//    // set call .........................................................
//    sndNmlPkg.basInf.callId = _PP_SetState;
//    // set parms ........................................................
//    sndNmlPkg.basInf.addr = addr;
//    chPkg = (char *)&sndNmlPkg;
//    // snd package ......................................................
//    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
//    if (rslt <= 0) return ERR_UNK;
//    chPkg = (char *)&rcvNmlPkg;
//    // rcv package ......................................................
//    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
//    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
//    // get parms ........................................................
//    return rcvNmlPkg.basInf.result;
//} // PP_SetState

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API PP_TakeSweep(long addr)
//{
//	ZeroNmlPkgsNxtEvnt();
//    // set call .........................................................
//    sndNmlPkg.basInf.callId = _PP_TakeSweep;
//    // set parms ........................................................
//    sndNmlPkg.basInf.addr = addr;
//    chPkg = (char *)&sndNmlPkg;
//    // snd package ......................................................
//    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
//    if (rslt <= 0) return ERR_UNK;
//    chPkg = (char *)&rcvNmlPkg;
//    // rcv package ......................................................
//    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
//    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
//    // get parms ........................................................
//    return rcvNmlPkg.basInf.result;
//} // PP_TakeSweep

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API PP_GetTraceCDF(long addr, double* trCDF, long trLen)
//{ // SAR - FIX - ??? - TODO - MANUAL UPDATE ...
//	ZeroNmlPkgsNxtEvnt();
//    // set call .........................................................
//    sndNmlPkg.basInf.callId = _PP_GetTraceCDF;
//    // set parms ........................................................
//    sndNmlPkg.basInf.addr = addr;
//	trCDF ...
//    sndNmlPkg.prms.longs[0] = trLen;
//    chPkg = (char *)&sndNmlPkg;
//    // snd package ......................................................
//    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
//    if (rslt <= 0) return ERR_UNK;
//    chPkg = (char *)&rcvNmlPkg;
//    // rcv package ......................................................
//    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
//    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
//    // get parms ........................................................
//    *trCDF = rcvNmlPkg.prms.dbls[0];
//    return rcvNmlPkg.basInf.result;
//} // PP_GetTraceCDF

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API PP_GetTraceCCDF(long addr, double* trCCDF, long trLen)
//{ // SAR - FIX - ??? - TODO - MANUAL UPDATE ...
//	ZeroTrcPkgsNxtEvnt();
//    // set call .........................................................
//    sndTrcPkg.basInf.callId = _PP_GetTraceCCDF;
//    // set parms ........................................................
//    sndTrcPkg.basInf.addr = addr;
//    sndTrcPkg.prms.longs[0] = trLen;
//    chPkg = (char *)&sndTrcPkg;
//    // snd package ......................................................
//    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
//    if (rslt <= 0) return ERR_UNK;
//    chPkg = (char *)&rcvTrcPkg;
//    // rcv package ......................................................
//    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
//    if ((rcvTrcPkg.basInf.nEventId & sndTrcPkg.basInf.eventId)!=0) return ERR_UNK;
//    // get parms ........................................................
//    *trCCDF = rcvTrcPkg.prms.dbls[0];
//    return rcvTrcPkg.basInf.result;
//} // PP_GetTraceCCDF

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API PP_GetTracePwrDensity(long addr, double* trPD, long trLen)
//{ // SAR - FIX - ??? - TODO - MANUAL UPDATE ...
//	ZeroTrcPkgsNxtEvnt();
//    // set call .........................................................
//    sndTrcPkg.basInf.callId = _PP_GetTracePwrDensity;
//    // set parms ........................................................
//    sndTrcPkg.basInf.addr = addr;
//    sndTrcPkg.prms.longs[0] = trLen;
//    chPkg = (char *)&sndTrcPkg;
//    // snd package ......................................................
//    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
//    if (rslt <= 0) return ERR_UNK;
//    chPkg = (char *)&rcvTrcPkg;
//    // rcv package ......................................................
//    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
//    if ((rcvTrcPkg.basInf.nEventId & sndTrcPkg.basInf.eventId)!=0) return ERR_UNK;
//    // get parms ........................................................
//    *trPD = rcvTrcPkg.prms.dbls[0];
//    return rcvTrcPkg.basInf.result;
//} // PP_GetTracePwrDensity

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetTraceAvgPower(long addr, double* avgPwr)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetTraceAvgPower;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *avgPwr = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetTraceAvgPower

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetTraceCrestFactor(long addr, double* CrF)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetTraceCrestFactor;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *CrF = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetTraceCrestFactor

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetTracePkPwr(long addr, double* pkPwr)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetTracePkPwr;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *pkPwr = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetTracePkPwr

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetTracePulsePower(long addr, double* plsPwr)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetTracePulsePower;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *plsPwr = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetTracePulsePower

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetTraceDC(long addr, double* dutyCycle)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetTraceDC;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *dutyCycle = rcvNmlPkg.prms.dbls[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetTraceDC

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetTriggerOut(long addr, TRIGGER_OUT_MODE trgOutMode)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetTriggerOut;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = (long)trgOutMode;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetTriggerOut

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetTriggerOut(long addr, TRIGGER_OUT_MODE *trgOutMode)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetTriggerOut;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
	*trgOutMode = (TRIGGER_OUT_MODE)rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetTriggerOut

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API PP_ResendState(long addr)
//{
//	ZeroNmlPkgsNxtEvnt();
//    // set call .........................................................
//    sndNmlPkg.basInf.callId = _PP_ResendState;
//    // set parms ........................................................
//    sndNmlPkg.basInf.addr = addr;
//    chPkg = (char *)&sndNmlPkg;
//    // snd package ......................................................
//    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
//    if (rslt <= 0) return ERR_UNK;
//    chPkg = (char *)&rcvNmlPkg;
//    // rcv package ......................................................
//    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
//    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
//    // get parms ........................................................
//    return rcvNmlPkg.basInf.result;
//} // PP_ResendState

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_ResetTraceAveraging(long addr)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_ResetTraceAveraging;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_ResetTraceAveraging

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetClosestSweepTimeUSEC(long  addr, long  swpTm)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetClosestSweepTimeUSEC;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = swpTm;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetClosestSweepTimeUSEC

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetPulseEdgesPosition(long addr, long pkIdx, long* leftTrIdx, long* rightTrIdx)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetPulseEdgesPosition;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = pkIdx;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *leftTrIdx  = rcvNmlPkg.prms.longs[1];
    *rightTrIdx = rcvNmlPkg.prms.longs[2];
    return rcvNmlPkg.basInf.result;
} // PP_GetPulseEdgesPosition

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetPulseEdgesTime(long addr, double pkTime, double* leftSide, double* rightSide)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetPulseEdgesTime;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.dbls[0] = pkTime;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *leftSide  = rcvNmlPkg.prms.dbls[1];
    *rightSide = rcvNmlPkg.prms.dbls[2];
    return rcvNmlPkg.basInf.result;
} // PP_GetPulseEdgesTime

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_GetTimeOut(long addr, long* tmoUSEC)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_GetTimeOut;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    *tmoUSEC = rcvNmlPkg.prms.longs[0];
    return rcvNmlPkg.basInf.result;
} // PP_GetTimeOut

/*=======================================================================
-----------------------------------------------------------------------*/
LB_API2_32_64_API PP_SetTimeOut(long addr, long tmoUSEC)
{
	ZeroNmlPkgsNxtEvnt();
    // set call .........................................................
    sndNmlPkg.basInf.callId = _PP_SetTimeOut;
    // set parms ........................................................
    sndNmlPkg.basInf.addr = addr;
    sndNmlPkg.prms.longs[0] = tmoUSEC;
    chPkg = (char *)&sndNmlPkg;
    // snd package ......................................................
    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
    if (rslt <= 0) return ERR_UNK;
    chPkg = (char *)&rcvNmlPkg;
    // rcv package ......................................................
    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
    // get parms ........................................................
    return rcvNmlPkg.basInf.result;
} // PP_SetTimeOut

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API PP_GetAutoTimeOutMode(long addr, FEATURE_STATE *tmoAutoMode)
//{
//	ZeroNmlPkgsNxtEvnt();
//    // set call .........................................................
//    sndNmlPkg.basInf.callId = _PP_GetAutoTimeOutMode;
//    // set parms ........................................................
//    sndNmlPkg.basInf.addr = addr;
//    chPkg = (char *)&sndNmlPkg;
//    // snd package ......................................................
//    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
//    if (rslt <= 0) return ERR_UNK;
//    chPkg = (char *)&rcvNmlPkg;
//    // rcv package ......................................................
//    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
//    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
//    // get parms ........................................................
//	*tmoAutoMode = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
//    return rcvNmlPkg.basInf.result;
//} // PP_GetAutoTimeOutMode

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API PP_SetAutoTimeOutMode(long addr, FEATURE_STATE tmoAutoMode)
//{
//	ZeroNmlPkgsNxtEvnt();
//    // set call .........................................................
//    sndNmlPkg.basInf.callId = _PP_SetAutoTimeOutMode;
//    // set parms ........................................................
//    sndNmlPkg.basInf.addr = addr;
//    sndNmlPkg.prms.longs[0] = (long)tmoAutoMode;
//    chPkg = (char *)&sndNmlPkg;
//    // snd package ......................................................
//    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
//    if (rslt <= 0) return ERR_UNK;
//    chPkg = (char *)&rcvNmlPkg;
//    // rcv package ......................................................
//    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
//    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
//    // get parms ........................................................
//    return rcvNmlPkg.basInf.result;
//} // PP_SetAutoTimeOutMode

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API PP_GetUndersampling20ms_50ms_100ms(long addr, FEATURE_STATE *tmoUndersampling)
//{
//	ZeroNmlPkgsNxtEvnt();
//    // set call .........................................................
//    sndNmlPkg.basInf.callId = _PP_GetUndersampling20ms_50ms_100ms;
//    // set parms ........................................................
//    sndNmlPkg.basInf.addr = addr;
//    chPkg = (char *)&sndNmlPkg;
//    // snd package ......................................................
//    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
//    if (rslt <= 0) return ERR_UNK;
//    chPkg = (char *)&rcvNmlPkg;
//    // rcv package ......................................................
//    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
//    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
//    // get parms ........................................................
//	*tmoUndersampling = (FEATURE_STATE)rcvNmlPkg.prms.longs[0];
//    return rcvNmlPkg.basInf.result;
//} // PP_GetUndersampling20ms_50ms_100ms

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API PP_SetUndersampling20ms_50ms_100ms(long addr, FEATURE_STATE tmoUndersampling)
//{
//	ZeroNmlPkgsNxtEvnt();
//    // set call .........................................................
//    sndNmlPkg.basInf.callId = _PP_SetUndersampling20ms_50ms_100ms;
//    // set parms ........................................................
//    sndNmlPkg.basInf.addr = addr;
//    sndNmlPkg.prms.longs[0] = (long)tmoUndersampling;
//    chPkg = (char *)&sndNmlPkg;
//    // snd package ......................................................
//    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
//    if (rslt <= 0) return ERR_UNK;
//    chPkg = (char *)&rcvNmlPkg;
//    // rcv package ......................................................
//    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
//    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
//    // get parms ........................................................
//    return rcvNmlPkg.basInf.result;
//} // PP_SetUndersampling20ms_50ms_100ms

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API PP_GetPeaksFromTr_Idx_Flat(double* tr,long trLen, long units, double peakCrit, double measThresh, long* trIdx, double* value, long maxPks, long* pksUsed)
//{ // SAR - FIX - ??? - TODO - MANUAL UPDATE ...
//	ZeroNmlPkgsNxtEvnt();
//    // set call .........................................................
//    sndNmlPkg.basInf.callId = _PP_GetPeaksFromTr_Idx_Flat;
//    // set parms ........................................................
//    //sndNmlPkg.basInf.addr = addr;
//	TRACE...
//	sndNmlPkg.prms.longs[0] = trLen;
//    sndNmlPkg.prms.longs[1] = units;
//    sndNmlPkg.prms.dbls[0] = peakCrit;
//    sndNmlPkg.prms.dbls[1] = measThresh;
//    sndNmlPkg.prms.longs[2] = maxPks;
//    chPkg = (char *)&sndNmlPkg;
//    // snd package ......................................................
//    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
//    if (rslt <= 0) return ERR_UNK;
//    chPkg = (char *)&rcvNmlPkg;
//    // rcv package ......................................................
//    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
//    if ((rcvNmlPkg.basInf.nEventId & sndNmlPkg.basInf.eventId)!=0) return ERR_UNK;
//    // get parms ........................................................
//    *trIdx = rcvNmlPkg.prms.longs[3];
//    *value = rcvNmlPkg.prms.dbls[3];
//    *pksUsed = rcvNmlPkg.prms.longs[4];
//    return rcvNmlPkg.basInf.result;
//} // PP_GetPeaksFromTr_Idx_Flat

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API PP_GetPeaksFromTr_Val_Flat(double* tr, long trLen, long units, double peakCrit, double measThresh, long* trIdx, double* value, long maxPks, long* pksUsed)
//{ // SAR - FIX - ??? - TODO - MANUAL UPDATE ...
//	ZeroTrcPkgsNxtEvnt();
//    // set call .........................................................
//    sndTrcPkg.basInf.callId = _PP_GetPeaksFromTr_Val_Flat;
//    // set parms ........................................................
//    //sndTrcPkg.basInf.addr = addr;
//    TRACE...
//    sndTrcPkg.prms.longs[0] = trLen;
//    sndTrcPkg.prms.longs[1] = units;
//    sndTrcPkg.prms.dbls[0] = peakCrit;
//    sndTrcPkg.prms.dbls[1] = measThresh;
//    sndTrcPkg.prms.longs[2] = maxPks;
//    chPkg = (char *)&sndTrcPkg;
//    // snd package ......................................................
//    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
//    if (rslt <= 0) return ERR_UNK;
//    chPkg = (char *)&rcvTrcPkg;
//    // rcv package ......................................................
//    if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
//    if ((rcvTrcPkg.basInf.nEventId & sndTrcPkg.basInf.eventId)!=0) return ERR_UNK;
//    // get parms ........................................................
//    *trIdx = rcvTrcPkg.prms.longs[3];
//    *value = rcvTrcPkg.prms.dbls[3];
//    *pksUsed = rcvTrcPkg.prms.longs[4];
//    return rcvTrcPkg.basInf.result;
//} // PP_GetPeaksFromTr_Val_Flat

/*=======================================================================
-----------------------------------------------------------------------*/
//LB_API2_32_64_API PP_GetAnalysisTrace(long addr, double* frequency, double* sweepTime, double*tr, long* trLen, PWR_UNITS* units)
//{ // SAR - FIX - ??? - TODO - MANUAL UPDATE ...
//	ZeroTrcPkgsNxtEvnt();
//    // set call .........................................................
//    sndTrcPkg.basInf.callId = _PP_GetAnalysisTrace;
//    // set parms ........................................................
//    sndTrcPkg.basInf.addr = addr;
//    sndTrcPkg.prms.dbls[0]  = *frequency;
//    sndTrcPkg.prms.dbls[1]  = *sweepTime;
//    TRACE ...
//    sndTrcPkg.prms.longs[0] = *trLen;
//	sndTrcPkg.prms.longs[1] = (PWR_UNITS)*units;
//    chPkg = (char *)&sndTrcPkg;
//    // snd package ......................................................
//    rslt = client.Send(chPkg, NORMAL_PACKAGE_SIZE);
//    if (rslt <= 0) return ERR_UNK;
//    chPkg = (char *)&rcvTrcPkg;
//    // rcv package ......................................................
//	if (client.Recv(chPkg, NORMAL_PACKAGE_SIZE)<=0) return ERR_UNK;
//    if ((rcvTrcPkg.basInf.nEventId & sndTrcPkg.basInf.eventId)!=0) return ERR_UNK;
//    // get parms ........................................................
//    return rcvTrcPkg.basInf.result;
//} // PP_GetAnalysisTrace


